require "SICK"


function love.load()
	
	
	version = 1.2
	love.window.setTitle("Square Invaders " .. version)
	
	love.filesystem.setIdentity("SquareInvaders")
	img = love.graphics.newImage("data/icon.png")
	love.window.setIcon( img:getData() )
	
	crosshair = love.mouse.newCursor("data/cursor.png", 12, 12)
    love.mouse.setCursor(crosshair)
	
	esrc = love.audio.newSource("data/laser.mp3")
	src = love.audio.newSource("data/laser.mp3")
	src2 = love.audio.newSource("data/effect.mp3")
	src3 = love.audio.newSource("data/effect2.mp3")
	src33 = love.audio.newSource("data/effect2.mp3")
	src4 = love.audio.newSource("data/effect3.mp3")
	src5 = love.audio.newSource("data/cdk_-_Drive_(Original_RumbleStep_Mix)_1.mp3")
	src6 = love.audio.newSource("data/effect4.mp3")
	src7 = love.audio.newSource("data/effect5.mp3")
	src8 = love.audio.newSource("data/button.mp3")
	src9 = love.audio.newSource("data/click.mp3")
	src10 = love.audio.newSource("data/pulldown.mp3")
	src11 = love.audio.newSource("data/boost.mp3")
	src12 = love.audio.newSource("data/laser2.mp3")
	src13 = love.audio.newSource("data/merge.mp3")
	src13:setPitch(1.2)
	
	src9:setPitch(3)
	src10:setPitch(0.6)
	
	font = love.graphics.newFont("data/ka1.ttf", 8)
	font2 = love.graphics.newFont("data/ka1.ttf", 11)
	font3 = love.graphics.newFont("data/ka1.ttf", 8)
	font4 = love.graphics.newFont("data/ka1.ttf", 7)
	font5 = love.graphics.newFont("data/ka1.ttf", 11)
	font6 = love.graphics.newFont("data/ka1.ttf", 9)
	love.graphics.setFont(font)
	love.graphics.setDefaultFilter( 'nearest', 'nearest', 0 )
	love.graphics.setColor(0,0,0)
	love.graphics.setBackgroundColor(10,10,10)
	
	
	logsw = true
	fpssw = false
	
	lzrsize = 0
	lzrsizem = 100
	lzrtime = 0
	lzrsec = 0
	lzrtimem = 1
	lzrlvl = 0
	lzrsw = false
	
	clicksw = false
	clicksw2 = false
	clicksw3 = false
	clicksw4 = false
	clicksw5 = false
	clicksw6 = false
	clicksw0 = false
	
	buttonsw = false
	buttonsw2 = false
	buttonsw3 = false
	buttonsw4 = false
	buttonsw5 = false
	buttonsw6 = false
	buttonsw0 = false
	
	fcol1 = 250
	fcol2 = 170
	fcol3 = 0
	
	rot = 30
	rot2 = 15
	rotsw1 = true
	rotsw2 = false
	
	randt = 0
	
	bcount = 0
	back = false
	spc = false
	spl = 1
	sstr = ""
	erase = false
	showscore = false
	typing = false
	
	stepsw = false
	
	performfileopen = love.filesystem.newFile("name.nm")
	performfileopen:open("r")
	Name = performfileopen:read()
	
	hscore = 0
	highscore.set("hs.hs", 10, "N/A", 0)
	for i, score, name in highscore() do
		if score > hscore then hscore = score end
	end
	
	function colliding( x1, y1, w1, h1, x2, y2, w2, h2 )
		if x1 + w1 > x2 and x1 < x2 + w2 and y1 + h1 > y2 and y1 < y2 + h2 then		
			return true			
		else
			return false	
		end
	end
	
	savscore = function()
		if Name == "" or Name == " " or Name == "CLICK HERE" then Name = "UNKNOWN" end
		performfileopen = love.filesystem.newFile("name.nm")
		performfileopen:open("w")
		performfileopen:write(Name)
		performfileopen:close()
		if Score > hscore then hscore = Score end
		highscore.add(Name, Score)
		highscore.save()
	end
	
	function reward()
		rand = love.math.random(11)
		
		while rand == randt do rand = love.math.random(11) end
		
		randt = rand
		if rand == 1 and shots == 1  and level > 2 then shots = shots + 1 msg = "+1 GUN" 
		elseif rand == 1 and shots == 2  and level > 6 then shots = shots + 1 msg = "+1 GUN"
		elseif rand == 1 and shots == 3  and level > 11 then shots = shots + 1 msg = "+1 GUN"
		else rand = love.math.random(2,11)
		end
		
		if rand == 2 and sradius <= 11 then sradius = sradius + 1 msg = "+1 SHOT SIZE" end
		if rand == 2 and sradius > 11 then rng46 = 1000 * love.math.random(level*6) Score = Score + rng46  msg = math.floor(rng46/3) .. " XP" end
		if rand == 3 then healthm = healthm + 25 health = health + math.floor(healthm/5) if health > healthm then healtht = health - healthm health = healthm else healtht = 0 end msg = "+" .. math.floor(healthm/5) - math.floor(healtht) .. "/25 HP" end
		if rand == 4 and stepsize < 7 then stepsize = stepsize + 1  msg = "+1 SPEED" end
		if rand == 4 and stepsize >= 7 and stepsize < 10 and level >= 10 then stepsize = stepsize + 1  msg = "+1 SPEED" end
		if rand == 4 and stepsize == 10 then rng45 = 1000 * love.math.random(level*6) Score = Score + rng45  msg = math.floor(rng45/3) .. " XP" end
		if rand == 4 and stepsize >= 7 and level < 10 then rng45 = 1000 * love.math.random(level*6) Score = Score + rng45  msg = math.floor(rng45/3) .. " XP" end
		if rand == 5 and speed <= 23 then speed = speed + 1 msg = "+1 GUN SPEED" end
		if rand == 5 and speed > 23 then if love.math.random(10) == 1 then rng58 = love.math.random(3) else rng58 = 0 end  hitpoints = hitpoints + 1 + rng58 msg = "+" .. 1 + rng58 .. " DAMAGE" end
		if rand == 6 then rng57 = 1000 * love.math.random(level*6) Score = Score + rng57 msg = math.floor(rng57/3) .. " XP"  end
		if rand == 7 then if love.math.random(6) == 1 then rng55 = love.math.random(2) else rng55 = 0 end  hitpoints = hitpoints + 1 + rng55 msg = "+" .. 1 + rng55 .. " DAMAGE" end
		if rand == 8 then hpregen = hpregen + 0.1 msg = "+0.1 REGEN/S" end
		if rand == 9 then rng567 = love.math.random(3) shieldm = shieldm + rng567 shieldc = shieldm msg = "+" .. rng567 .. " SHIELD" end
		if rand == 10 then rng563 = love.math.random(3) boostm = boostm + rng563 boostc = boostm msg = "+" .. rng563 .. " BOOST" end
		if rand == 11 and lzrlvl < 20 then lzrtimem = lzrtimem + 0.1 lzrsizem = lzrsizem + 5 lzrlvl = lzrlvl + 1 lzrtime = 0 msg = "+1 LSR BLAST" end
		if rand == 11 and lzrlvl >= 20 then rng51 = 1000 * love.math.random(level*6) Score = Score + rng51 msg = math.floor(rng51/3) .. " XP" end
		
	end
	
	mouseX1 = 0
	mouseY1 = 0
	mouseX2 = 0
	mouseY2 = 0
	mouseX3 = 0
	mouseY3 = 0
	
	start = true
	
	chk = false
	scroll = 0
	scroll2 = 0
	scrolls = false
	scrolls2 = false
	
	sndcount = 0
	sounds = true
	music = true
	mute = false
	
	keym = 16
	keyy2 = 0
	keyx2 = 0
	keyx = 0
	keyy = 0
	keyc = 0
	
	boostm = 0
	boostc = 0
	boostsec = 0
	boost = false
	boostsw = false
	boostsw2 = false
	boostt = 0
	
	shieldm = 0
	shieldc = 0
	shieldsec = 0
	shieldt = 0
	
	totsec = 0
	dsec = 0
	dps = 0
	adps = 0
	dls = 0
	dpm = 0
	dtot = 0
	
	sec = 0
	min = 0
	hour = 0
	timestr = ""
	
	dmgsec = 0
	
	secra = 10
	secc = 0
	secm = 4
	secdst = 0
	
	rotation = 0
	
	secretx = 0
	secrety = 0
	
	ebullets = {}
	pointerX = 0
	pointerY = 0
	
	playerx = 400
	playery = 300
	tx = 0
	ty = 0
	
	ebull = false
	
	stain = false
	stain2 = false
	count = 0
	count2 = 0
	count3 = 0
	rng = 0
	rng2 = 0
	seg = 8
	fires = false
	shot = false
	shots = 1
	bullets = {}
	stx = -100
	sty = -100
	sradius = 3
	speed = 10
	sps = speed
	scount = 0
	str = 1
	sup = false
	sdown = false
	sleft = false
	sright = false
	lvl1 = true
	Score = 0
	rew = 100
	killed = 0
	level = 1
	tlevel = 1
	exp = 0
	expm = 1000
	
	pkx = 0
	pky = 0
	pkw = 15
	pkh = 15
	loot = false
	loot2 = false
	msg = ""
	msgs = false
	msgc = 0
	msgx = 0
	msgy = 0
	
	hpregen = 0.0
	regsec = 0
	
	hitpoints = 5
	health = 100
	healthm = 100
	healtht = 0
	radius = 8 + (health/16)
	dmg = false
	
	entim = 0
	enemies = {}
	encount = 0
	emsgt = {}
	emsglen = 0
	
	secpla = function()
		rng664 = love.math.random(4)
		
		if rng664 == 1 then secretx = 1000 + love.math.random(3000) secrety = 800 + love.math.random(3000) end
		if rng664 == 2 then secretx = -200 + love.math.random(-3000,0) secrety = -200 + love.math.random(-3000,0) end
		if rng664 == 3 then secretx = 1000 + love.math.random(3000) secrety = -200 + love.math.random(-3000,0) end
		if rng664 == 4 then secretx = -200 + love.math.random(-3000,0) secrety = 800 + love.math.random(3000) end
	end
	
	secpla()
	
	enfunc = function()
			if Score < 5000 then lvl = 1 end
			if Score > 5000 then lvl = 2 end
			if Score > 10000 then lvl = 3 end
			if Score > 20000 then lvl = 4 end
			if Score > 40000 then  lvl = 5 end
			if Score > 80000 then  lvl = 6 end
			if Score > 150000 then  lvl = 7 end
			if Score > 300000 then lvl = 8 end
			if Score > 500000 then lvl = 9 end
			if Score > 900000 then  lvl = 10 end
			if Score > 1200000 then lvl = 11 end
			if Score > 1500000 then lvl = 12 end
			if Score > 2000000 then lvl = 13 end
			if Score > 3000000 then lvl = 14 end
			if Score > 4000000 then lvl = 15 end
			if Score > 5000000 then lvl = 16 end
			if Score > 7000000 then lvl = 17 end
			if Score > 10000000 then lvl = 18 end
			if Score > 14000000 then lvl = 19 end
			if Score > 18000000 then lvl = 20 end
			rng765 = love.math.random(-2,4)
			if love.math.random(10) == 1 then 
				lvl = lvl + rng765
				if love.math.random(2) == 1 then stepsw = true end
			end
			
			if lvl > 20 then lvl = 20 end
			if lvl < 1 then lvl = 1 end
			
			if lvl == 1 then helt = 8 + love.math.random(6) step = 3 end
			if lvl == 2 then helt = 15 + love.math.random(10) step = 3 end
			if lvl == 3 then helt = 20 + love.math.random(20) step = 4 end
			if lvl == 4 then helt = 30 + love.math.random(20) step = 4 end
			if lvl == 5 then helt = 40 + love.math.random(20) step = 4 end
			if lvl == 6 then helt = 50 + love.math.random(20) step = 4 end
			if lvl == 7 then helt = 60 + love.math.random(20) step = 4 end
			if lvl == 8 then helt = 70 + love.math.random(40) step = 5 end
			if lvl == 9 then helt = 90 + love.math.random(50) step = 5 end
			if lvl == 10 then helt = 100 + love.math.random(100) step = 5 end
			if lvl == 11 then helt = 130 + love.math.random(100) step = 6 end
			if lvl == 12 then helt = 150 + love.math.random(140) step = 6  end
			if lvl == 13 then helt = 280 + love.math.random(180) step = 6  end
			if lvl == 14 then helt = 340 + love.math.random(200) step = 7 end
			if lvl == 15 then helt = 480 + love.math.random(200) step = 7 end
			if lvl == 16 then helt = 540 + love.math.random(300) step = 7 end
			if lvl == 17 then helt = 600 + love.math.random(400) step = 8 end
			if lvl == 18 then helt = 800 + love.math.random(500) step = 8 end
			if lvl == 19 then helt = 1000 + love.math.random(600) step = 8 end
			if lvl == 20 then helt = 2000 + love.math.random(1000) step = 9 end
			if stepsw and lvl < 14 then step = step + love.math.random(3) stepsw = false end
			heltt = helt
			wdt = 5 + helt/5
			hgt = 5 + helt/5
			
			
			rng09 = love.math.random(4)
			if rng09 == 1 then 
				X = 860 + wdt + love.math.random(1000)
				Y = love.math.random(-600,1200)
			end
		
			if rng09 == 2 then 
				X = -60 - wdt - love.math.random(1000)
				Y = love.math.random(-600,1200)
			end
			
			if rng09 == 3 then 
				Y = 660 + wdt + love.math.random(1000)
				X = love.math.random(-800,1600)
			end
		
			if rng09 == 4 then 
				Y = -60 - wdt - love.math.random(1000)
				X = love.math.random(-800,1600)
			end
			
			
			xs = X
			ys = Y
			tup = false
			tdown = false
			tleft = false
			tright = false
			sw = false
			Hit = false
			slowy = Y
			slowx = X
			local colr = 255
			local colg = 30 + love.math.random(100)
			local colb = 30 + love.math.random(30)
			local wdtdif = love.math.random(200,600)
			local hgtdif = love.math.random(150,450)
			
			local estartX = xs
			local estartY = ys
			local eX = playerx
			local eY = playery
        
			local eangle = math.atan2((eY - estartY), (eX - estartX))
        
			local ebulletDx = (3 * 20) * math.cos(eangle)
			local ebulletDy = (3 * 20) * math.sin(eangle)
			
			
			table.insert(enemies, {merges = 0, path = love.math.random(1,2), dx = ebulletDx, dy = ebulletDy, hit = Hit, rectx = X, recty = Y, ehelt = helt, eheltt = heltt, elvl = lvl, rectw = wdt, recth = hgt, rectxs = xs, rectys = ys, rup = tup, rdown = tdown, rleft = tleft, rright = tright, esw = sw, slowY = slowy, slowX = slowx, steprect = step, hgt = hgtdif, wdf = wdtdif, ecol1 = colr, ecol2 = colg, ecol3 = colb})
			encount = encount + 1
		
	end
	enfunc()
	
	rectm = " !"
	
	dst = 900
	
	stepsize = 4
	stepn = 1
	
	col1 = 80
	col2 = 150
	col3 = 41
	colt1 = false
	colt2 = true
	colt3 = false
	colp = false
	
	up = false
	down = false
	left = false
	right = false
	
	gameOver = false
	gameIsPaused = true
	pause = true
	
	x100 = 100
	x200 = 200
	x300 = 300
	x400 = 400
	x500 = 500
	x600 = 600
	x700 = 700
	x800 = 800
	
	y100 = 100
	y200 = 200
	y300 = 300
	y400 = 400
	y500 = 500
	y600 = 600
	
	ytemp = 0
	xtemp = 0
	
	restart = function()
		
		savscore()
		loot = false
		
		level = 1
		tlevel = 1
		rew = 100
		gameOver = false
		Score = 0
		killed = 0
		health = 100
		healthm = 100
		hitpoints = 5
		playerx = 400
		playery = 300
		tx = 0
		ty = 0
		radius = 10
		shot = false
		sup = false
		sdown = false
		sleft = false
		sright = false
		sradius = 3
		speed = 10
		stepsize = 4
		stepn = 1
		gameIsPaused = false
		pause = false
		x100 = 100
		x200 = 200
		x300 = 300
		x400 = 400
		x500 = 500
		x600 = 600
		x700 = 700
		x800 = 800
	
		y100 = 100
		y200 = 200
		y300 = 300
		y400 = 400
		y500 = 500
		y600 = 600
		secc = 0
		
		hour = 0
		min = 0
		sec = 0
		
		hpregen = 0
		regsec = 0
		
		shieldm = 0
		shieldc = 0
		shieldsec = 0
		sheildt = 0
		
		shots = 1
		
		lzrsize = 0
		lzrsizem = 100
		lzrtime = 0
		lzrtimem = 1
		lzrlvl = 0
		lzrsw = false
		
		boostm = 0
		boostc = 0
		boostsec = 0
		boost = false
		boostt = 0
		
		totsec = 0
		dsec = 0
		dps = 0
		dpm = 0
		dtot = 0
		
		for r = 1, 1000 do
			table.remove(ebullets)
		end
		
		for k = 1,encount do
			table.remove(enemies,encount)
			encount = encount - 1
		end
		enfunc()
		secpla()
	end
	
	function format_int(number)

		local i, j, minus, int, fraction = tostring(number):find('([-]?)(%d+)([.]?%d*)')
		int = int:reverse():gsub("(%d%d%d)", "%1,")
		return minus .. int:reverse():gsub("^,", "") .. fraction
	end
	
end

function love.draw()
	
	love.graphics.setBackgroundColor(col1,col2,col3)

	love.graphics.setColor(0,0,0,150)
	
	love.graphics.line( x100 + 2, 0 + 2, x100 + 2, 600 + 2)
	love.graphics.line( x200 + 2, 0 + 2, x200 + 2, 600 + 2)
	love.graphics.line( x300 + 2, 0 + 2, x300 + 2, 600 + 2)
	love.graphics.line( x400 + 2, 0 + 2, x400 + 2, 600 + 2)
	love.graphics.line( x500 + 2, 0 + 2, x500 + 2, 600 + 2)
	love.graphics.line( x600 + 2, 0 + 2, x600 + 2, 600 + 2)
	love.graphics.line( x700 + 2, 0 + 2, x700 + 2, 600 + 2)
	love.graphics.line( x800 + 2, 0 + 2, x800 + 2, 600 + 2)
	
	love.graphics.line( 0 + 2, y100 + 2, 800 + 2, y100 + 2)
	love.graphics.line( 0 + 2, y200 + 2, 800 + 2, y200 + 2)
	love.graphics.line( 0 + 2, y300 + 2, 800 + 2, y300 + 2)
	love.graphics.line( 0 + 2, y400 + 2, 800 + 2, y400 + 2)
	love.graphics.line( 0 + 2, y500 + 2, 800 + 2, y500 + 2)
	love.graphics.line( 0 + 2, y600 + 2, 800 + 2, y600 + 2)
	
	
	love.graphics.setColor(240 + love.math.random(10), 80,80,150)
	
	--love.graphics.line( 400, 0, 400, 600)
	love.graphics.line( x100 + 1, 0 + 1, x100 + 1, 600 + 1)
	love.graphics.line( x200 + 1, 0 + 1, x200 + 1, 600 + 1)
	love.graphics.line( x300 + 1, 0 + 1, x300 + 1, 600 + 1)
	love.graphics.line( x400 + 1, 0 + 1, x400 + 1, 600 + 1)
	love.graphics.line( x500 + 1, 0 + 1, x500 + 1, 600 + 1)
	love.graphics.line( x600 + 1, 0 + 1, x600 + 1, 600 + 1)
	love.graphics.line( x700 + 1, 0 + 1, x700 + 1, 600 + 1)
	love.graphics.line( x800 + 1, 0 + 1, x800 + 1, 600 + 1)
	
	love.graphics.line( 0 + 1, y100 + 1, 800 + 1, y100 + 1)
	love.graphics.line( 0 + 1, y200 + 1, 800 + 1, y200 + 1)
	love.graphics.line( 0 + 1, y300 + 1, 800 + 1, y300 + 1)
	love.graphics.line( 0 + 1, y400 + 1, 800 + 1, y400 + 1)
	love.graphics.line( 0 + 1, y500 + 1, 800 + 1, y500 + 1)
	love.graphics.line( 0 + 1, y600 + 1, 800 + 1, y600 + 1)
	
	love.graphics.setColor(100+(col3/5),200+(col2/5),0,150)
	
	love.graphics.line( x100, 0, x100, 600)
	love.graphics.line( x200, 0, x200, 600)
	love.graphics.line( x300, 0, x300, 600)
	love.graphics.line( x400, 0, x400, 600)
	love.graphics.line( x500, 0, x500, 600)
	love.graphics.line( x600, 0, x600, 600)
	love.graphics.line( x700, 0, x700, 600)
	love.graphics.line( x800, 0, x800, 600)
	
	love.graphics.line( 0, y100, 800, y100)
	love.graphics.line( 0, y200, 800, y200)
	love.graphics.line( 0, y300, 800, y300)
	love.graphics.line( 0, y400, 800, y400)
	love.graphics.line( 0, y500, 800, y500)
	love.graphics.line( 0, y600, 800, y600)
	
	
	
	love.graphics.setColor(0,0,0)
	if dmg == true then love.graphics.setColor(255,0,0) end
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius, seg ) end
	love.graphics.setColor(0,0,0)
	
	
	if secretx > 0 and secretx < 800 and secrety > 0 and secrety < 600 then love.graphics.circle( "fill", secretx, secrety, secra + 1, 4 ) end
	
	
	
	if loot == true then
		love.graphics.circle( "fill", pkx, pky, 9, 3 )
	end
	
	
	if lzrsw then
		love.graphics.setColor(255,col2-40,0,100)
		love.graphics.rectangle("fill",playerx-(lzrsize/2),playery-(lzrsize/2),lzrsize,lzrsize)
		love.graphics.setColor(255,0,0,200)
		love.graphics.rectangle("line",playerx-(lzrsize/2)-1,playery-(lzrsize/2)-1,lzrsize+2,lzrsize+2)
	end
	love.graphics.setColor(col3-40,col2-40,col1-40)
	
	
	--love.graphics.setColor(50+(col3/2)+love.math.random(20),150+(col2/4)+love.math.random(20),50+(col3/2)+love.math.random(20))
	for i,v in ipairs(bullets) do
		love.graphics.setColor(150,255,0,30 + love.math.random(225))
		love.graphics.circle( "fill", v.x, v.y, sradius+1+love.math.random(2), 50 )
		love.graphics.setColor(0,0,0)
		love.graphics.circle( "fill", v.x, v.y, sradius+1, 50 )
		love.graphics.setColor(v.col1,v.col2,col3)
		love.graphics.circle( "fill", v.x, v.y, sradius, 50 )
	end
	
	for i,v in ipairs(enemies) do
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle( "fill", v.rectx-1, v.recty-1, v.rectw+2, v.recth+2 )
		love.graphics.setColor(love.math.random(80,255),love.math.random(80,150),0)
		love.graphics.rectangle( "fill", v.rectx, v.recty, v.rectw, v.recth )
		love.graphics.setColor(v.ecol1-70,v.ecol2-29,v.ecol3-29)
		love.graphics.rectangle( "fill", v.rectx+1, v.recty+1, v.rectw-2, v.recth-2 )
		love.graphics.setColor(love.math.random(80,255),love.math.random(80,150),0,150)
		love.graphics.line(v.rectx+1, v.recty+1, v.rectx + v.rectw-1, v.recty + v.recth-1)
		love.graphics.line(v.rectx+1, v.recty + v.recth-1, v.rectx + v.rectw-1, v.recty+1 )
		for i,v in ipairs(ebullets) do
		
			love.graphics.setColor(0,0,0)
			love.graphics.circle( "fill", v.x, v.y, v.esradius+2, 8 )
		
			love.graphics.setColor(255,0,0,30 + love.math.random(225))
			love.graphics.circle( "fill", v.x, v.y, v.esradius+1, 8 )
		
			love.graphics.setColor(v.col1,v.col2,col3)
			love.graphics.circle( "fill", v.x, v.y, v.esradius, 8 )
		end
	end
	
	
	if loot == true then 
		love.graphics.setColor(love.math.random(20,255),255,20)
		love.graphics.circle( "fill", pkx, pky, 7, 3 )
		love.graphics.setColor(207,207,26,200)
		love.graphics.circle( "fill", pkx, pky, 6, 3 )
		
	end
	
		
		if secretx > 0 and secretx < 800 and secrety > 0 and secrety < 800 then 
			love.graphics.setColor(love.math.random(20,255),255,20)
			love.graphics.circle( "fill", secretx, secrety, secra, 4 )
			love.graphics.setColor(153,207,26,200)
			love.graphics.circle( "fill", secretx, secrety, secra-1, 4 ) 
		end
	
	
	love.graphics.setColor(love.math.random(80,255),love.math.random(180),0)
	
	if gameOver == false and pause == false and up == true and left == false and down == false and right == false then 
		love.graphics.circle( "fill", playerx, playery+16+(health/60)-(count/2), radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx, playery+23+(health/60)-(count/2), radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx, playery+28+(health/60)-(count/2), radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx, playery+28+(health/60)-(count/2), radius-(radius/3), love.math.random(2,9) )
		
	elseif gameOver == false and pause == false and up == true and right == true and left == false and down == false then
		love.graphics.circle( "fill", playerx-11-(health/60)+(count/2), playery+11+(health/60)-(count/2), radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-15-(health/60)+(count/2), playery+15+(health/60)-(count/2), radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery+19+(health/60)-(count/2), radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery+19+(health/60)-(count/2), radius-(radius/3), love.math.random(2,9) )
		
	elseif gameOver == false and pause == false and up == true and left == true and right == false and down == false then
		love.graphics.circle( "fill", playerx+11+(health/60)-(count/2), playery+11+(health/60)-(count/2), radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+15+(health/60)-(count/2), playery+15+(health/60)-(count/2), radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery+19+(health/60)-(count/2), radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery+19+(health/60)-(count/2), radius-(radius/3), love.math.random(2,9) )
	end
	
	if gameOver == false and pause == false and down == true and up == false and left == false and right == false then 
		love.graphics.circle( "fill", playerx, playery-16-(health/60)+(count/2), radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx, playery-23-(health/60)+(count/2), radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx, playery-28-(health/60)+(count/2), radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx, playery-28-(health/60)+(count/2), radius-(radius/3), love.math.random(2,9) )
		
	elseif gameOver == false and pause == false and down == true and right == true and up == false and left == false then
		love.graphics.circle( "fill", playerx-11-(health/60)+(count/2), playery-11-(health/60)+(count/2), radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-15-(health/60)+(count/2), playery-15-(health/60)+(count/2), radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery-19-(health/60)+(count/2), radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery-19-(health/60)+(count/2), radius-(radius/3), love.math.random(2,9) )
		
	elseif gameOver == false and pause == false and down == true and left == true and up == false and right == false then
		love.graphics.circle( "fill", playerx+11+(health/60)-(count/2), playery-11-(health/60)+(count/2), radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+15+(health/60)-(count/2), playery-15-(health/60)+(count/2), radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery-19-(health/60)+(count/2), radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery-19-(health/60)+(count/2), radius-(radius/3), love.math.random(2,9) )
	end
	
	if gameOver == false and pause == false and left == true and up == false and down == false and right == false then 
		love.graphics.circle( "fill", playerx+16+(health/60)-(count/2), playery, radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+23+(health/60)-(count/2), playery, radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+28+(health/60)-(count/2), playery, radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx+28+(health/60)-(count/2), playery, radius-(radius/3), love.math.random(2,9) )
	end
	
	if gameOver == false and pause == false and right == true and up == false and down == false and left == false then 
		love.graphics.circle( "fill", playerx-16-(health/60)+(count/2), playery, radius-(radius/6), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-23-(health/60)+(count/2), playery, radius-(radius/5), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-28-(health/60)+(count/2), playery, radius-(radius/4), love.math.random(2,9) )
		love.graphics.circle( "fill", playerx-28-(health/60)+(count/2), playery, radius-(radius/3), love.math.random(2,9) )
	end
	
	--
	
	love.graphics.setColor(fcol1,fcol2,fcol3,150)
	
	if gameOver == false and pause == false and up == true and left == false and down == false and right == false then 
		love.graphics.circle( "fill", playerx, playery+16+(health/60)-(count/2), radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx, playery+23+(health/60)-(count/2), radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx, playery+28+(health/60)-(count/2), radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx, playery+28+(health/60)-(count/2), radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
	elseif gameOver == false and pause == false and up == true and right == true and left == false and down == false then
		love.graphics.circle( "fill", playerx-11-(health/60)+(count/2), playery+11+(health/60)-(count/2), radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx-15-(health/60)+(count/2), playery+15+(health/60)-(count/2), radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery+19+(health/60)-(count/2), radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery+19+(health/60)-(count/2), radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
		
	elseif gameOver == false and pause == false and up == true and left == true and right == false and down == false then
		love.graphics.circle( "fill", playerx+11+(health/60)-(count/2), playery+11+(health/60)-(count/2), radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx+15+(health/60)-(count/2), playery+15+(health/60)-(count/2), radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery+19+(health/60)-(count/2), radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery+19+(health/60)-(count/2), radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
	end
	
	if gameOver == false and pause == false and down == true and up == false and left == false and right == false then 
		love.graphics.circle( "fill", playerx, playery-16-(health/60)+(count/2), radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx, playery-23-(health/60)+(count/2), radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx, playery-28-(health/60)+(count/2), radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx, playery-28-(health/60)+(count/2), radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
		
	elseif gameOver == false and pause == false and down == true and right == true and left == false and up == false then
		love.graphics.circle( "fill", playerx-11-(health/60)+(count/2), playery-11-(health/60)+(count/2), radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx-15-(health/60)+(count/2), playery-15-(health/60)+(count/2), radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery-19-(health/60)+(count/2), radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx-19-(health/60)+(count/2), playery-19-(health/60)+(count/2), radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
		
	elseif gameOver == false and pause == false and down == true and left == true and right == false and up == false then
		love.graphics.circle( "fill", playerx+11+(health/60)-(count/2), playery-11-(health/60)+(count/2), radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx+15+(health/60)-(count/2), playery-15-(health/60)+(count/2), radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery-19-(health/60)+(count/2), radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx+19+(health/60)-(count/2), playery-19-(health/60)+(count/2), radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
	end
	
	if gameOver == false and pause == false and left == true and up == false and down == false and right == false then 
		love.graphics.circle( "fill", playerx+16+(health/60)-(count/2), playery, radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx+23+(health/60)-(count/2), playery, radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx+28+(health/60)-(count/2), playery, radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx+28+(health/60)-(count/2), playery, radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
	end
	
	if gameOver == false and pause == false and right == true and up == false and down == false and left == false then 
		love.graphics.circle( "fill", playerx-16-(health/60)+(count/2), playery, radius-(radius/4), seg )
		love.graphics.circle( "fill", playerx-23-(health/60)+(count/2), playery, radius-(radius/3), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,50)
		love.graphics.circle( "fill", playerx-28-(health/60)+(count/2), playery, radius-(radius/2), seg )
		love.graphics.circle( "fill", playerx-28-(health/60)+(count/2), playery, radius-(radius/2), seg )
		love.graphics.setColor(fcol1,fcol2,fcol3,150)
	end
	
	love.graphics.setColor(0,0,0)
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius+1, seg ) end
	love.graphics.setColor(130,210,0,230)
	if count < 20 and count > 15 then love.graphics.setColor(255,215,0) end
	if dmg == true then love.graphics.setColor(255,0,0) end
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius, seg ) end
	
	
	love.graphics.setColor(0,0,0)
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius, 4 ) end
	love.graphics.setColor(140,200,0)
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-3, 8 ) end
	
	love.graphics.setColor(0,0,0)
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-5, 4 ) end
	love.graphics.setColor(150,190,0)
	if count < 15 and count > 10 then love.graphics.setColor(255,215,0,230) end
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-7, 8 ) end
	
	
	love.graphics.setColor(0,0,0)
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-9, 4 ) end
	love.graphics.setColor(160,180,0)
	if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-11, 8 ) end
	
	
	if health > 110 then
		love.graphics.setColor(0,0,0)
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-13, 4 ) end
		love.graphics.setColor(170,170,0)
		if count < 10 and count > 5 then love.graphics.setColor(255,215,0,230) end
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-15, 8 ) end
	end
	
	if health > 150 then
		love.graphics.setColor(0,0,0)
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-17, 4 ) end
		love.graphics.setColor(180,160,0)
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-19, 8 ) end
	end
	
	if health > 250 then
		love.graphics.setColor(0,0,0)
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-21, 4 ) end
		love.graphics.setColor(190,150,0)
		if count < 5 then love.graphics.setColor(255,215,0,230) end
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-23, 8 ) end
	end
	
	if health > 300 then
		love.graphics.setColor(0,0,0)
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-25, 4 ) end
		love.graphics.setColor(130,100,0)
		if gameOver == false then love.graphics.circle( "fill", playerx, playery, radius-27, 4 ) end
	end
	
	if gameOver == false and shieldc > 0 then
		love.graphics.setColor(50,0,(shieldc/shieldm)*255,40)
		love.graphics.circle( "fill", playerx, playery, radius+((shieldc/shieldm)*8), seg ) 
		love.graphics.setColor(200,0,(shieldc/shieldm)*255,30)
		love.graphics.circle( "fill", playerx, playery, radius+((shieldc/shieldm)*8+2), seg )
	end
	
	if stain then 
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx + love.math.random(5), sty + love.math.random(5), 3 + love.math.random(100), 3 + love.math.random(7) )
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx + love.math.random(5), sty + love.math.random(5), 3 + love.math.random(100), 3 + love.math.random(7) )
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx + love.math.random(15), sty + love.math.random(15), 3 + love.math.random(100), 3 + love.math.random(7) )
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx + love.math.random(15), sty + love.math.random(15), 3 + love.math.random(100), 3 + love.math.random(7) )
	end
	
	if stain2 then 
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx, sty, 3 + love.math.random(20), 3 + love.math.random(7) )
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx, sty, 3 + love.math.random(20), 3 + love.math.random(7) )
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx + love.math.random(15), sty + love.math.random(15), 3 + love.math.random(20), 3 + love.math.random(7) )
		love.graphics.setColor(love.math.random(255),love.math.random(255),0,170)
		love.graphics.circle( "fill", stx + love.math.random(15), sty + love.math.random(15), 3 + love.math.random(20), 3 + love.math.random(7) )
	end
	
	love.graphics.setFont(font5)
	
	for i,v in ipairs(enemies) do
		if v.rup or v.rdown or v.rleft or v.rright then
			love.graphics.setColor(0,0,0,150)
			love.graphics.print(rectm,v.rectxs+1,v.rectys+1)
			love.graphics.setColor(love.math.random(100,255),50,0,150)
			love.graphics.print(rectm,v.rectxs,v.rectys)
		end	
	end
	
	if secretx > -1200 and secretx < 2000 and secrety > -1000 and secrety < 1800 then 
			pointerX = secretx - 4
			pointerY = secrety - 6
	
			if pointerX < 2 then pointerX = 2 end
			if pointerX > 790 then pointerX = 790 end
		
			if pointerY < 19 then pointerY = 19 end
			if pointerY > 572 then pointerY = 572 end
			
			
			love.graphics.setColor(0,0,0)
			love.graphics.print("?",pointerX+1,pointerY+1) 
			
			love.graphics.setColor(love.math.random(50,255),love.math.random(50,255),0)
			love.graphics.print("?",pointerX,pointerY) 
	end
	
	
	
	
	
	
	for i,v in ipairs(enemies) do
		love.graphics.setFont(font3)
		love.graphics.setColor(0,0,0)
		love.graphics.print("LEVEL " .. v.elvl,v.slowX+1+(v.rectw/2)-(font3:getWidth("LEVEL " .. v.elvl)/2),v.slowY - 24)
		love.graphics.setColor(255,267-(v.elvl*12),20)
		love.graphics.print("LEVEL " .. v.elvl,v.slowX+(v.rectw/2)-(font3:getWidth("LEVEL " .. v.elvl)/2),v.slowY - 25)
	
		love.graphics.setFont(font4)
		love.graphics.setColor(0,0,0,150)
		hpstring = v.ehelt .. "/" .. v.eheltt
		love.graphics.print(hpstring, v.slowX+1+(v.rectw/2) - (font4:getWidth(hpstring)/2), v.slowY - 12)
		love.graphics.setColor(255,267-(v.elvl*12),20)
		love.graphics.print(hpstring, v.slowX+(v.rectw/2) - (font4:getWidth(hpstring)/2), v.slowY - 13)
	
		love.graphics.setColor(0,0,0,100)
		love.graphics.rectangle("fill", v.slowX+1+(v.rectw/2)-19, v.slowY - 17, 37, 4 )	
		
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("line", v.slowX+1+(v.rectw/2)-19, v.slowY - 17, 37, 4 )
		
		love.graphics.setColor(255,255,255)
		
		if v.ehelt > v.eheltt/1.5 then love.graphics.setColor(0,255,0) end
		if v.ehelt <= v.eheltt/1.5 and v.ehelt >= v.eheltt/3 then love.graphics.setColor(255,255,0) end
		if v.ehelt < v.eheltt/3 then love.graphics.setColor(255,0,0) end
	
		love.graphics.rectangle("fill", v.slowX+1+(v.rectw/2)-18 , v.slowY - 16, (35 * (v.ehelt/v.eheltt)), 2)
		
	end 
	
	for i,v in ipairs(emsgt) do
		if v.emsgc >= 35 then love.graphics.setColor(0,0,0,255 - ((v.emsgc-35)*7.2)) end
		if v.emsgc < 35 then love.graphics.setColor(0,0,0,255) end
		love.graphics.print(v.emsg,v.x+1,v.y - (v.emsgc*3) + 1)
		
		if v.emsgc >= 35 then love.graphics.setColor(v.r,v.g,v.b,255 - ((v.emsgc-35)*7.2)) end
		if v.emsgc < 35 then love.graphics.setColor(v.r,v.g,v.b,255) end
		love.graphics.print(v.emsg,v.x,v.y - (v.emsgc*3))
	end
	
	if #emsgt < 35 then emsgtlen = #emsgt end
	if #emsgt > 34 then emsgtlen = 34 end
	
	if #emsgt > 0 and logsw then
		love.graphics.setColor(0,0,0,60)
		love.graphics.rectangle("fill", 10,532-(emsgtlen * 15),128,(emsgtlen * 15))
		love.graphics.setColor(100+(col3/5),200+(col2/5),0,150)
		love.graphics.rectangle("line", 9,531-(emsgtlen * 15),130,(emsgtlen * 15)+2)
	end
	
	love.graphics.setFont(font3)
	
	for i,v in ipairs(emsgt) do
		if logsw then
			if string.sub(v.emsg,1,1) == "-" then
				if i < 35 and v.line == 0 then 
					love.graphics.setColor(0,0,0)
					love.graphics.print(v.time .. string.sub(v.emsg,2,-1) .. " DMG DONE",13,521-(15*(emsgtlen-i)))
					love.graphics.setColor(v.r,v.g,v.b,255)
					love.graphics.print(v.time .. string.sub(v.emsg,2,-1) .. " DMG DONE",12,520-(15*(emsgtlen-i))) 
				end
			
				if i < 35 and v.line == 1 then
					love.graphics.setColor(0,0,0)
					love.graphics.print(v.time .. string.sub(v.emsg,2,-1) .. " HP LOST",13,521-(15*(emsgtlen-i)))
					love.graphics.setColor(v.r,v.g,v.b,255)
					love.graphics.print(v.time .. string.sub(v.emsg,2,-1) .. " HP LOST",12,520-(15*(emsgtlen-i)))				
				end
			else
				if i < 35 then 
					love.graphics.setColor(0,0,0)
					love.graphics.print(v.time .. v.emsg,13,521-(15*(emsgtlen-i)))
					love.graphics.setColor(v.r,v.g,v.b,255)				
					love.graphics.print(v.time .. v.emsg,12,520-(15*(emsgtlen-i)))
				end
			end
		end
	end
	
	love.graphics.setFont(font)
	
	--love.graphics.print(x100 .. " " .. x200 .. " " .. x300 .. " " .. x400 .. " " .. x500 .. " " .. x600 .. " " .. x700 .. " " .. x800,3,16)
	--love.graphics.print(y100 .. " " .. y200 .. " " .. y300 .. " " .. y400 .. " " .. y500 .. " " .. y600,3,26)
	
	
	if gameIsPaused or scrolls == true or scrolls2 then
		if start then
			love.graphics.setColor(col1,col2,col3)
			love.graphics.rectangle("fill", 0,0,800,600)
		end
		
		love.graphics.setColor(0,30,0,200)
		love.graphics.rectangle("fill", 200, 18 + scroll - scroll2, 400, 567 )
		
		love.graphics.setColor(40,180,0)
		love.graphics.rectangle("fill", 199, 18 + scroll - scroll2, 1, 567 )
		love.graphics.rectangle("fill", 599, 18 + scroll - scroll2, 1, 567 )
		
		dff = 10
		love.graphics.setColor(20,90,0)
		if love.mouse.getX() > 250 and love.mouse.getX() < 550 and love.mouse.getY() > 48 + dff + scroll - scroll2 and love.mouse.getY() < 76 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw == false and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw = true
			end
			love.graphics.setColor(90+math.random(40),90+math.random(40),0)
			if love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw = true
				end
				if pause == false and gameOver == false then
					gameIsPaused = true
					pause = true
				elseif gameOver == true then
					loot = false
					level = 1
					tlevel = 1
					ehelt = 5
					eheltt = ehelt
					esw = false
					elvl = 1
					ehelt2 = 10
					eheltt2 = ehelt2
					esw2 = false
					elvl2 = 1
					rew = 100
					gameOver = false
					Score = 0
					killed = 0
					health = 100
					healthm = 100
					hitpoints = 5
					playerx = 400
					playery = 300
					tx = 0
					ty = 0
					radius = 10
					rectx = -60
					recty = 300
					rectx2 = dst
					recty2 = dst
					rectw = 20
					recth = 20
					rectw2 = 40
					recth2 = 40
					lvl1 = true
					shot = false
					sup = false
					sdown = false
					sleft = false
					sright = false
					sradius = 3
					speed = 10
					stepsize = 4
					stepn = 1
					gameIsPaused = false
					pause = false
					x100 = 100
					x200 = 200
					x300 = 300
					x400 = 400
					x500 = 500
					x600 = 600
					x700 = 700
					x800 = 800
	
					y100 = 100
					y200 = 200
					y300 = 300
					y400 = 400
					y500 = 500
					y600 = 600
					secc = 0
		
					hour = 0
					min = 0
					sec = 0
					
					hpregen = 0
					regsec = 0
					
					shieldm = 0
					shieldc = 0
					shieldsec = 0
					sheildt = 0
					
					shots = 1
					
					lzrsize = 0
					lzrsizem = 100
					lzrtime = 0
					lzrtimem = 1
					lzrlvl = 0
					lzrsw = false
					
					boostm = 0
					boostc = 0
					boostsec = 0
					boost = false
					boostt = 0
					
					totsec = 0
					dsec = 0
					dps = 0
					dpm = 0
					dtot = 0
					
					
					for r = 1, 1000 do
						table.remove(ebullets)
					end
		
					for k = 1,encount do
						table.remove(enemies,encount)
						encount = encount - 1
					end
					enfunc()
					secpla()
					
					gameIsPaused = false
					pause = false
					chk = true
					scrolls = true
					scrolls2 = false
					scroll = 0
					if sounds then
						src10:setVolume(1)
						src10:stop()
						src10:play()
					end
					
				elseif gameOver == false then
					gameIsPaused = false
					pause = false
					chk = true
					scrolls = true
					scrolls2 = false
					scroll = 0
					if sounds then
						src10:setVolume(1)
						src10:stop()
						src10:play()
					end
				end
			else
				clicksw = false
			end
		else
			buttonsw = false
		end
		
		love.graphics.rectangle("fill", 250, 48 + dff + scroll - scroll2, 300, 30 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 252, 50 + dff + scroll - scroll2, 296, 26 )
		
		--
		
		love.graphics.setColor(20,90,0)
		if love.mouse.getX() > 250 and love.mouse.getX() < 550 and love.mouse.getY() > 88 + dff - scroll - scroll2 and love.mouse.getY() < 116 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw2 == false and not start and not gameOver and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw2 = true
			end
			if not start and not gameOver then love.graphics.setColor(90+math.random(40),90+math.random(40),0) end
			if not start and not gameOver and love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw2 == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw2 = true
				end
				if sounds then
					src10:setVolume(1)
					src10:stop()
					src10:play()
				end
				scrolls = true
				scroll = 0
				restart()
			else
				clicksw2 = false
			end
		else	
			buttonsw2 = false
		end
		
		love.graphics.rectangle("fill", 250, 88 + dff + scroll - scroll2, 300, 30 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 252, 90 + dff + scroll - scroll2, 296, 26 )
		
		--
		
		love.graphics.setColor(20,90,0)
		if love.mouse.getX() > 250 and love.mouse.getX() < 550 and love.mouse.getY() > 128 + dff + scroll - scroll2 and love.mouse.getY() < 156 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw0 == false and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw0 = true
			end
			love.graphics.setColor(90+math.random(40),90+math.random(40),0)
			if love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw0 == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw0 = true
				end
				
				if love.window.getFullscreen(true) then
					love.window.setFullscreen(false, "normal")
		 
				else
					love.window.setFullscreen(true, "normal")
				end
			else
				clicksw0 = false
			end
		else	
			buttonsw0 = false
		end
		
		love.graphics.rectangle("fill", 250, 128 + dff + scroll - scroll2, 300, 30 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 252, 130 + dff + scroll - scroll2, 296, 26 )
		
		--
		
		love.graphics.setColor(20,90,0)
		if love.mouse.getX() > 250 and love.mouse.getX() < 550 and love.mouse.getY() > 168 + dff + scroll - scroll2 and love.mouse.getY() < 196 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw3 == false and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw3 = true
			end
			love.graphics.setColor(90+math.random(40),90+math.random(40),0)
			if sndcount > 10 and love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw3 == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw3 = true
				end
				sndcount = 0
				if not mute then
					mute = true
					sounds = false
					src:stop()
					src2:stop()
					src3:stop()
					src4:stop()
					src6:stop()
				
					music = false
					src5:stop()
				else
					mute = false
					music = true
					sounds = true
				end
					
				
			else
				clicksw3 = false
			end
		else
			buttonsw3 = false
		end
		
		love.graphics.rectangle("fill", 250, 168 + dff + scroll - scroll2, 300, 30 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 252, 170 + dff + scroll - scroll2, 296, 26 )
		
		--
		
		love.graphics.setColor(20,90,0)
		if love.mouse.getX() > 250 and love.mouse.getX() < 550 and love.mouse.getY() > 208 + dff + scroll - scroll2 and love.mouse.getY() < 236 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw4 == false and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw4 = true
			end
			love.graphics.setColor(90+math.random(40),90+math.random(40),0)
			if love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw4 == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw4 = true
				end
				showscore = true
				love.graphics.setColor(100+(col3/5),200+(col2/5),0)
				
				for i, score, name in highscore() do
					if score > hscore then hscore = score end
					love.graphics.printf(i .. ".", 220,366 + scroll - scroll2 - 5 + (i * 19),360, 'left')
					love.graphics.printf(name, 240,366 + scroll - scroll2 - 5 + (i * 19),360, 'left')
					love.graphics.printf("-", 220,366 + scroll - scroll2 - 5 + (i * 19),360, 'center')
					love.graphics.printf(format_int(score*2), 220,366 + scroll - scroll2 - 5 + (i * 19),360, 'right')
				end
				
			else 
				clicksw4 = false
				showscore = false
				
			end
		else
			buttonsw4 = false
		end
		
		love.graphics.rectangle("fill", 250, 208 + dff + scroll - scroll2, 300, 30 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 252, 210 + dff + scroll - scroll2, 296, 26 )
		
		--
		
		
		love.graphics.setColor(20,90,0)
		if love.mouse.getX() > 250 and love.mouse.getX() < 550 and love.mouse.getY() > 248 + dff + scroll - scroll2 and love.mouse.getY() < 276 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw5 == false and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw5 = true
			end
			love.graphics.setColor(90+math.random(40),90+math.random(40),0)
			if love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw5 == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw5 = true
				end
				if not gameOver then savscore() end
				love.event.quit()
			else
				clicksw5 = false
			end
		else
			buttonsw5 = false
		end
		
		love.graphics.rectangle("fill", 250, 248 + dff + scroll - scroll2, 300, 30 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 252, 250 + dff + scroll - scroll2, 296, 26 )
		
		--
		
		love.graphics.setColor(20,90,0)
		if typing then love.graphics.setColor(50+math.random(40),50+math.random(40),0) end
		if love.mouse.getX() > 300 and love.mouse.getX() < 500 and love.mouse.getY() > 316 + dff + scroll - scroll2 and love.mouse.getY() < 356 + dff + scroll - scroll2 and gameIsPaused then 
			if buttonsw6 == false and sounds then
				src8:setVolume(1)
				src8:stop()
				src8:play()
				buttonsw6 = true
			end
			love.graphics.setColor(90+math.random(40),90+math.random(40),0)
			if typing then love.graphics.setColor(50+math.random(40),50+math.random(40),0) end
			if love.mouse.isDown("l") or love.keyboard.isDown("return") then
				if clicksw6 == false and sounds then
					src9:setVolume(1)
					src9:stop()
					src9:play()
					clicksw6 = true
				end
				if Name == "CLICK HERE" or Name == "UNKNOWN" then Name = "" end
				typing = true
				love.keyboard.setTextInput(true)
			else
				clicksw6 = false
			end
			
		else
			
			if love.mouse.isDown("l") or love.keyboard.isDown("return") then
					typing = false
					love.keyboard.setTextInput(false)
			end
			buttonsw6 = false
		end
		
		
		love.graphics.rectangle("fill", 300, 316 + dff + scroll - scroll2, 200, 20 )
		love.graphics.setColor(0,0,0,150)
		love.graphics.rectangle("fill", 302, 318 + dff + scroll - scroll2, 196, 16 )
	end
	
	love.graphics.setColor(60,60,0,220)
	love.graphics.rectangle("fill", 0, 0, 800, 17 )
	
	love.graphics.setColor(40,180,0)
	love.graphics.rectangle("fill", 0, 17, 800, 1 ) 
	
	love.graphics.setColor(60,60,0,220)
	love.graphics.rectangle("fill", 0, 585, 800, 600 )
	
	love.graphics.setColor(40,180,0)
	love.graphics.rectangle("fill", 0, 584, 800, 1 ) 
	
	love.graphics.setFont(font)
	love.graphics.setColor(100+(col3/5),200+(col2/5),0)
	if not start then love.graphics.printf( "LEVEL: " .. level .. " - XP: " .. format_int(exp) .. "/" .. format_int(expm) .. " - SCORE: " .. format_int(Score*2) .. " - HIGHSCORE: " .. format_int(hscore*2) .. " - KILLS: " .. format_int(killed) .. " - DPS: " .. format_int(string.format("%.2f",adps)) .. "/" .. format_int(dls) .. "/" .. format_int(dpm) .. timestr , 0, 5, 800, 'center' ) end
	if not start then love.graphics.printf( "REGEN/S: " .. hpregen .. " - SPEED: " .. stepsize-3 .. "/7 - BOOST: " .. boostm .. "  - LASER BLAST: " .. lzrlvl .. "/20 - SHOT SIZE: " .. sradius - 2 .. "/10 - GUN SPEED: " .. speed - 9 .. "/15 - GUNS: " .. shots .. "/4 - DAMAGE: " .. format_int(hitpoints) , 0, 589, 800, 'center' ) end
	love.graphics.setFont(font6)
	if not start then 
	
	love.graphics.setColor(0,0,0,60)
	love.graphics.rectangle("fill", 10,538,128,34)
	love.graphics.setColor(100+(col3/5),200+(col2/5),0,150)
	love.graphics.rectangle("line", 9,537,130,36)
		
		if shieldm > 0 then 
			love.graphics.setColor(0,0,0)
			love.graphics.print("SHIELD:",14,540)
			love.graphics.print(shieldc .. "/" .. shieldm,59,540)
			
			love.graphics.setColor(80+(col3/5),150+(col2/5),190)
			love.graphics.print("SHIELD:",13,539)
			love.graphics.print(shieldc .. "/" .. shieldm,58,539)
			
			love.graphics.setColor(0,0,0,120)
			love.graphics.rectangle("fill", 115, 557, 20, 14 )
			
			love.graphics.rectangle("line", 115, 557, 20, 14 )
			
			love.graphics.setColor(80+(col3/5),150+(col2/5),190)
			love.graphics.rectangle("fill", 116 , 558, (18 * (shieldc/shieldm)), 12)
			
			
			love.graphics.setColor(0,0,0,120)
			love.graphics.line(124,558,126,570)
			
		end
		love.graphics.setColor(0,0,0)
		love.graphics.print("HEALTH:",14,549)
		love.graphics.print(math.floor(health) .. "/" .. healthm,59,549)
		love.graphics.setColor(100+(col3/5),200+(col2/5),0)
		love.graphics.print("HEALTH:",13,548) 
		love.graphics.print(math.floor(health) .. "/" .. healthm,58,548) 
		love.graphics.setColor(0,0,0,120)
		love.graphics.rectangle("fill", 12, 557, 100, 14 )
		
		love.graphics.rectangle("line", 12, 557, 100, 14 )
	
		if health > healthm/1.5 then love.graphics.setColor(0,255,0) end
		if health <= healthm/1.5 and health >= healthm/3 then love.graphics.setColor(255,255,0) end
		if health < healthm/3 then love.graphics.setColor(255,0,0) end
		love.graphics.rectangle("fill", 13 , 558, (98 * (health/healthm)), 12)
		
		for hl = 1,9 do
			love.graphics.setColor(0,0,0,120)
			love.graphics.line(12 + (10 * hl),558, 14 + (10 * hl), 570)
		end
	end
	love.graphics.setFont(font)
	if not start and boostm > 0 then
		if boostsec < 0 and not boostsw2 and boostc ~= boostm then 
			love.graphics.setColor(0,0,0)
			love.graphics.print(100-math.floor((0-boostsec/3)*100) .. "%",776,459)
			love.graphics.setColor(255,255+boostsec*85,0)
			love.graphics.print(100-math.floor((0-boostsec/3)*100) .. "%",775,458) 
		end
		
		love.graphics.setColor(0,0,0)
		love.graphics.print( "B", 767, 532 )
		love.graphics.setColor(100+(col3/5),200+(col2/5),0)
		love.graphics.print( "B", 766, 531 )
		
		for th = 0,1 do
			love.graphics.setColor(0,0,0)
			love.graphics.print( "O", 767, 540+(th*8) )
			love.graphics.setColor(100+(col3/5),200+(col2/5),0)
			love.graphics.print( "O", 766, 539+(th*8) )
		end
		
		love.graphics.setColor(0,0,0)
		love.graphics.print( "S", 767, 555 )
		love.graphics.setColor(100+(col3/5),200+(col2/5),0)
		love.graphics.print( "S", 766, 554 )
		
		love.graphics.setColor(0,0,0)
		love.graphics.print( "T", 767, 563 )
		love.graphics.setColor(100+(col3/5),200+(col2/5),0)
		love.graphics.print( "T", 766, 562 )
		
		
		love.graphics.setColor(0,0,0,120)
		love.graphics.rectangle("fill", 776, 470, 12, 100 )
		
		love.graphics.rectangle("line", 776, 470, 12, 100 )
	
		love.graphics.setColor(255-(255*(boostc/boostm)),255,0)
		love.graphics.rectangle("fill", 777, 471 + 98 - (98 * (boostc/boostm)), 10, (98 * (boostc/boostm)) )
		
		for hj = 1,9 do
			love.graphics.setColor(0,0,0,120)
			love.graphics.line(777,469 + (hj*10),787,471 + (hj*10))
		end
	end
	
	if lzrtime < 0 and not gameIsPaused then
		love.graphics.setColor(0,0,0)
		love.graphics.printf( "CHARGING LASER BLAST READY IN " .. math.floor(1-lzrtime) .. " SECONDS" , 1, 569, 801, 'center' )
		love.graphics.setColor(0-(lzrtime*4.25),255,0)
		love.graphics.printf( "CHARGING LASER BLAST READY IN " .. math.floor(1-lzrtime) .. " SECONDS" , 0, 568, 800, 'center' )
	end
	
	love.graphics.setColor(100+(col3/5),200+(col2/5),0)
	love.graphics.setFont(font2)
	conty = -40
	if gameIsPaused or scrolls == true or scrolls2 then
		
		if start then love.graphics.printf("NEW GAME",0,58 + dff + scroll - scroll2,800,'center') end
		if gameOver then love.graphics.printf("NEW GAME",0,58 + dff + scroll - scroll2,800,'center') end
		if not start and not gameOver then love.graphics.printf("CONTINUE",0,58 + dff + scroll - scroll2,800,'center') end
		if start or gameOver then love.graphics.setColor(0,70,0) end
		love.graphics.printf("RESTART GAME",0,98 + dff + scroll - scroll2,800,'center')
		love.graphics.setColor(100+(col3/5),200+(col2/5),0)
		if not love.window.getFullscreen(true) then love.graphics.printf("FULLSCREEN",0,138 + dff + scroll - scroll2,800,'center') end
		if love.window.getFullscreen(true) then love.graphics.printf("WINDOWED",0,138 + dff + scroll - scroll2,800,'center') end
		love.graphics.printf("HIGHSCORES",0,218 + dff + scroll - scroll2,800,'center')
		love.graphics.printf("QUIT",0,258 + dff + scroll - scroll2,800,'center')
		if not mute then love.graphics.printf("MUTE ALL",0,178 + dff + scroll - scroll2,800,'center') end
		if mute then love.graphics.printf("UNMUTE ALL",0,178 + dff + scroll - scroll2,800,'center') end
		
		conty2 = 20
		
		if not showscore then
		love.graphics.printf("CREDITS:",0,527 + conty + conty2 + scroll - scroll2 - 5,800,'center')
		love.graphics.setFont(font)
		love.graphics.printf("MADE BY LUDVIG ALEXANDER VERPE",0,540 + conty + conty2 + scroll - scroll2 - 5,800,'center')
		love.graphics.printf("SOUNDS FROM: HTTP://WWW.FREESFX.CO.UK",0,553 + conty + conty2 + scroll - scroll2 - 5,800,'center')
		love.graphics.printf("SONG: DRIVE (ORIGINAL RUMBLESTEP MIX)",0,566 + conty + conty2 + scroll - scroll2 - 5,800,'center')
		love.graphics.printf("BY: CDK FEATURING DARRYL J",0,579 + conty + conty2 + scroll - scroll2 - 5, 800,'center')
		love.graphics.printf("SONG/LICENSE: CCMIXTER.ORG/FILES/CDK/43076",0,592 + conty + conty2 + scroll - scroll2 - 5, 800,'center')
		love.graphics.setFont(font2)
		love.graphics.printf("CONTROLS:",0,398 + conty + scroll - scroll2,800,'center')
		love.graphics.setFont(font)
		love.graphics.printf("WASD/ZQSD - MOVE",0,412 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("MOUSE/ARROWS - AIM",0,424 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("LMB/ENTER - GUN/SELECT",0,436 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("E - BLAST",0,448 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("RMB/SPACE - BOOST",0,460 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("F1 - FULLSCREEN/WINDOWED",0,472 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("F2 - TURN ON/OFF MUSIC",0,484 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("F3 - TURN ON/OFF SOUND",0,496 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("F4 - TURN ON/OFF LOG",0,508 + conty + scroll - scroll2,800,'center')
		love.graphics.printf("ESC - PAUSE GAME",0,520 + conty + scroll - scroll2,800,'center')
		end
	end
	
	--love.graphics.print(x100 .. " " .. x200 .. " " .. x300 .. " " .. x400 .. " " .. x500 .. " " .. x600 .. " " .. x700 .. " " .. x800,2,15)
	--love.graphics.print(y100 .. " " .. y200 .. " " .. y300 .. " " .. y400 .. " " .. y500 .. " " .. y600,2,25)
	
	
	love.graphics.setColor(100+(col3/5),200+(col2/5),0)
	love.graphics.setFont(font2)
	if fpssw then love.graphics.print("FPS: " .. love.timer.getFPS( ), 700, 20) end
	if pause and not start then love.graphics.printf( "Game is paused", 0, 28 + dff + scroll - scroll2 , 800 , 'center' ) end
	
	if gameIsPaused or scrolls or scrolls2 then
		love.graphics.printf( "NAME:", 0, 300 + dff + scroll - scroll2 , 800 , 'center' )
		love.graphics.printf( Name .. sstr, 0 - spl + 1, 321 + dff + scroll - scroll2 , 800 - spl + 1, 'center' )
	end
	
	if gameOver then love.graphics.printf( "Game Over", 0, 28 + dff + scroll - scroll2 , 800 , 'center' ) end
	love.graphics.setFont(font)
	
	love.graphics.setColor(col3-40,col2-40,col1-40)

	
end

function love.update(dt)

	
	if love.keyboard.isDown("return") then
		if not gameIsPaused and fires == false then fires = true else fires = false end
    end
	
	if love.keyboard.isDown("up") then
		keyc = keyc + 0.4
		if keyc > keym then keyc = keym end
		keyy = -4 - keyc
	else
		keyy = 0
    end
	
	if love.keyboard.isDown("down") then
		keyc = keyc + 0.4
		if keyc > keym then keyc = keym end
		keyy2 = 4 + keyc
	else
		keyy2 = 0
    end
	
	if love.keyboard.isDown("left") then
		keyc = keyc + 0.4
		if keyc > keym then keyc = keym end
		keyx = -4 - keyc
	else
		keyx = 0
    end
	
	if love.keyboard.isDown("right") then
		keyc = keyc + 0.4
		if keyc > keym then keyc = keym end
		keyx2 = 4 + keyc
	else
		keyx2 = 0
    end
	
	if keyy ~= 0 or keyx ~= 0 or keyy2 ~= 0 or keyx2 ~= 0 then love.mouse.setPosition( love.mouse.getX() + keyx + keyx2, love.mouse.getY() + keyy + keyy2 ) else keyc = 0 end
	
	if totsec > 0 then adps = dtot/totsec end
	
	sndcount = sndcount + (60 * dt)
	if count <= 0.1 then if not start then love.window.setTitle("Square Invaders " .. version .. " - Score: " .. format_int(Score*2)) end end 
	if not start and music then
		src5:setVolume(0.8)
		src5:play()
	end
	
	if colp == false then
		if col1 > 50 then colt1 = true end
		if col2 > 170 then colt2 = true end
		if col3 > 170 then colt3 = true end
	
		if col1 < 40 then colt1 = false end
		if col2 < 40 then colt2 = false end
		if col3 < 40 then colt3 = false end
		
		if math.floor(count3) == 2 then
			if colt1 == false and love.math.random(2) == 1 then col1 = col1 + 1 end
		end
		
		if math.floor(count3) == 4 then
			if colt2 == false and love.math.random(4) == 1 then col2 = col2 + 1 end
		end
		
		if math.floor(count3) == 6 then
			if colt3 == false and love.math.random(6) == 1 then col3 = col3 + 1 end
		end
		
		if math.floor(count3) == 2 then
			if colt1 == true and love.math.random(2) == 1 then col1 = col1 - 1 end
		end
		
		if math.floor(count3) == 4 then
			if colt2 == true and love.math.random(4) == 1 then col2 = col2 - 1 end
		end
		
		if math.floor(count3) == 6 then
			if colt3 == true and love.math.random(6) == 1 then col3 = col3 - 1 end
		end
	end
	count = count + (60 * dt)
	if count >= 20 then count = 0  sstr = "" spl = 1 end
	if count >= 10 and typing then sstr = "|" spl = 0 end
	count2 = count2 + (60 * dt)
	if count2 >= 20 then count2 = 0 stain = false end
	count3 = count3 + 1
	if count3 >= 10 then count3 = 0 stain2 = false end
	
	scount = scount + (40 * dt)
	if scount >= 17-math.floor(sps/2) then scount = 0 sps = speed end
	
	if scrolls then scroll = scroll + (2040 * dt) end
	if scrolls2 then scroll2 = scroll2 + (2400 * dt) end
	if scroll > 600 and scrolls then chk = false scrolls = false scroll = 0 end
	if scroll2 > 0 and scrolls2 then scrolls2 = false scroll2 = 0 end
	
	bcount = bcount + (60 * dt)
	if bcount >= 14 and back then
		bcount = 0
		Name = string.sub(Name,1,-2)
		if sounds then
			src9:setVolume(1)
			src9:stop()
			src9:play()
		end
	end
	
	if gameIsPaused then
		return 
	end

	
	if health > healthm then health = healthm end
	
	for i,v in ipairs(emsgt) do
		v.emsgc = v.emsgc + (18 * dt)
		if v.emsgc > 70 then
			table.remove(emsgt, i)
		end
	end
	
	lzrtime = lzrtime + dt
	lzrsec = lzrsec + dt
	
	if lzrtime > 0 and lzrmsg then
		table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx - 30, y = playery - 20, emsgc = 0, emsg = "BLAST READY!", r = 0, g = 255, b = 100})
		lzrmsg = false
	end
	
	if lzrsw then
		if sounds then
			src12:setVolume(0.5)
			src12:stop()
			src12:play()
		end
		
		lzrsize = lzrsize + 6
		if lzrsize > lzrsizem then lzrsize = lzrsizem end
	end
	
	if lzrtime > lzrtimem and lzrsw then
		lzrsw = false
		lzrmsg = true
		lzrtime = -60
		lzrsize = 0
	end
	
	
	
	dmgsec = dmgsec + dt
	
	boostsec = boostsec + dt
	if boostsec >= 0.05 and boostc < boostm then boostsec = 0 boostc = boostc + 0.05 end
	if boostc > boostm then boostc = boostm end
	if love.mouse.isDown("r") or love.keyboard.isDown(" ") then boostsw = true else boostsw = false end
	if boost and boostsw then
		if sounds then
			src11:setPitch(1 + (boostc/boostm)/2)
			src11:setVolume(1)
			src11:stop()
			src11:play()
		end
		boostsw2 = true
		radius = 8 + (health/24)
		boostc = boostc - 0.05 
		boostt = 4 
		boostsec = -3 
	else 
		boostsw2 = false
		boostt = 0 
		radius = 8 + (health/16)
	end
	
	if boostc <= 0 and boost then boostsw2 = false boost = false boostsec = -3 boostc = 0 end
	if boostc > 0 then boost = true end
	
	shieldsec = shieldsec + dt
	if shieldsec >= 1 and shieldc < shieldm then shieldsec = 0 shieldc = shieldc + 1 end
	
	regsec = regsec + dt
	if regsec >= 1 then regsec = 0 health = health + hpregen end
	
	start = false
	entim = entim + dt
	if math.floor(entim) >= 1 and #enemies <= 3 + level then entim = 0 enfunc() end
	
	totsec = totsec + dt
	
	dsec = dsec + dt
	if dsec > 1 then dls = dps dps = 0 dsec = 0 end
	if dpm < dps then dpm = dps end
	
	sec = sec + dt
	if sec >= 60 then sec = 0 min = min + 1 if min == 60 then min = 0 hour = hour + 1 end end
	
	if hour > 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MINS " .. math.floor(sec) .. " SECS" end
	if hour > 1 and min == 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MIN " .. math.floor(sec) .. " SECS" end
	if hour > 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MINS " .. math.floor(sec) .. " SEC" end
	if hour > 1 and min == 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MIN " .. math.floor(sec) .. " SEC" end
	if hour == 1 then timestr = " - TIME: " .. hour .. " HR " .. min .. " MINS " .. math.floor(sec) .. " SECS" end
	if hour == 1 and min == 1 then timestr = " - TIME: " .. hour .. " HR " .. min .. " MIN " .. math.floor(sec) .. " SECS" end
	if hour == 1 and math.floor(sec) == 1 then timestr = "   TIME: " .. hour .. " HOUR " .. min .. " MINUTES " .. math.floor(sec) .. " SEC" end
	if hour == 0 and min > 1 then timestr = " - TIME: " .. min .. " MINS " .. math.floor(sec) .. " SECS" end
	if hour == 0 and min == 1 then timestr = " - TIME: " .. min .. " MIN " .. math.floor(sec) .. " SECS" end
	if hour == 0 and min == 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. min .. " MIN " .. math.floor(sec) .. " SEC" end
	if hour == 0 and min > 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. min .. " MINS " .. math.floor(sec) .. " SEC" end
	if min == 0 and hour == 0 then timestr =" - TIME: " .. math.floor(sec) .. " SECS" end
	if min == 0 and hour == 0 and math.floor(sec) == 1 then timestr =" - TIME: " .. math.floor(sec) .. " SEC" end
	
	if secretx > 4000 then secpla() end
	if secretx < -4800 then secpla() end
	if secrety > 4000 then secpla() end
	if secrety < -4600 then secpla() end
	
	if fires and scount == 0 then
		if sounds then
			src:setVolume(0.2)
			src:stop()
			src:play()
		end
        local startX = playerx
        local startY = playery
		
		
		mouseX1 = love.mouse.getX()
		mouseY1 = love.mouse.getY()
		
		mouseX2 = love.mouse.getX()
		mouseY2 = love.mouse.getY()
		
		mouseX3 = love.mouse.getX()
		mouseY3 = love.mouse.getY()
        
        local angle = math.atan2((mouseY1 - startY), (mouseX1 - startX))
		local angle2 = math.atan2((mouseY2 - startY), (mouseX2 - startX))
		local angle3 = math.atan2((mouseY3 - startY), (mouseX3 - startX))
        
		if shots == 1 or shots >= 3 then
			bulletDx = speed * 50 * math.cos(angle)
			bulletDy = speed * 50 * math.sin(angle)
		else 
			bulletDx = speed * 50 * math.cos(angle+(sradius/50))
			bulletDy = speed * 50 * math.sin(angle+(sradius/50))
		end
		local bulletDx2 = speed * 50 * math.cos(angle2-(sradius/50))
        local bulletDy2 = speed * 50 * math.sin(angle2-(sradius/50))
		
		local bulletDx3 = speed * 50 * math.cos(angle3+(sradius/50))
        local bulletDy3 = speed * 50 * math.sin(angle3+(sradius/50))
		
		local colr = 100+love.math.random(55)
		local colg = 100+love.math.random(55)
		local colb = 100+love.math.random(55)
        
        table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy,col1 = colr, col2 = colg, col3 = colb})
		if shots >= 2 then table.insert(bullets, {x = startX, y = startY, dx = bulletDx2, dy = bulletDy2,col1 = colr, col2 = colg, col3 = colb}) end
		if shots >= 3 then table.insert(bullets, {x = startX, y = startY, dx = bulletDx3, dy = bulletDy3,col1 = colr, col2 = colg, col3 = colb}) end
		if shots >= 4 then table.insert(bullets, {x = startX, y = startY, dx = -bulletDx, dy = -bulletDy,col1 = colr, col2 = colg, col3 = colb}) end
		if shots >= 5 then table.insert(bullets, {x = startX, y = startY, dx = -bulletDx2, dy = -bulletDy2,col1 = colr, col2 = colg, col3 = colb}) end
		if shots >= 6 then table.insert(bullets, {x = startX, y = startY, dx = -bulletDx3, dy = -bulletDy3,col1 = colr, col2 = colg, col3 = colb}) end
	end
	
	xplus = 11
	
	exp = math.floor(Score / 3)
	if Score < 3000 then expm = 3000/3 end
	
	if Score >= 3000 and tlevel == 1 then level = 2 tlevel = level expm = math.floor(7000/3) msg = "Level 2!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play() end end 
	if Score >= 7000 and tlevel == 2 then level = 3 tlevel = level expm = math.floor(15000/3) msg = "Level 3!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 15000 and tlevel == 3 then level = 4 tlevel = level expm = math.floor(32000/3) msg = "Level 4!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 32000 and tlevel == 4 then level = 5 tlevel = level expm = math.floor(65000/3) msg = "Level 5!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 65000 and tlevel == 5 then level = 6 tlevel = level expm = math.floor(130000/3) msg = "Level 6!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 	
	if Score >= 130000 and tlevel == 6 then level = 7 tlevel = level expm = math.floor(270000/3) msg = "Level 7!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 270000 and tlevel == 7 then level = 8 tlevel = level expm = math.floor(470000/3) msg = "Level 8!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 470000 and tlevel == 8 then level = 9 tlevel = level expm = math.floor(830000/3) msg = "Level 9!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 830000 and tlevel == 9 then level = 10 tlevel = level expm = math.floor(900000/3) msg = "Level 10!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 900000 and tlevel == 10 then level = 11 tlevel = level expm = math.floor(1300000/3) msg = "Level 11!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 1300000 and tlevel == 11 then level = 12 tlevel = level expm = math.floor(1700000/3) msg = "Level 12!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 1700000 and tlevel == 12 then level = 13 tlevel = level expm = math.floor(2600000/3) msg = "Level 13!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 2600000 and tlevel == 13 then level = 14 tlevel = level expm = math.floor(3700000/3) msg = "Level 14!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 3700000 and tlevel == 14 then level = 15 tlevel = level expm = math.floor(4600000/3) msg = "Level 15!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 4600000 and tlevel == 15 then level = 16 tlevel = level expm = math.floor(6400000/3) msg = "Level 16!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 6400000 and tlevel == 16 then level = 17 tlevel = level expm = math.floor(9000000/3) msg = "Level 17!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end 
	if Score >= 9000000 and tlevel == 17 then level = 18 tlevel = level expm = math.floor(13000000/3) msg = "Level 18!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end
	if Score >= 13000000 and tlevel == 18 then level = 19 tlevel = level expm = math.floor(17000000/3) msg = "Level 19!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) if sounds then src7:setVolume(1) src7:stop() src7:play()end end
	if Score >= 17000000 and tlevel == 19 then level = 20 tlevel = level expm = 0 msg = "Level 20!" table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + xplus, y = playery - 20, emsgc = 0, emsg = msg, r = 50, g = 255, b = 100}) src7:setVolume(1) if sounds then src7:stop() src7:play()end end 
	
	for i,v in ipairs(enemies) do
	
		for b,m in ipairs(enemies) do
			if colliding(v.rectx,v.recty,v.rectw,v.recth,m.rectx,m.recty,m.rectw,m.recth) and b ~= i and v.ehelt == v.eheltt and m.ehelt == m.eheltt then
				if sounds then src13:play() end
				m.eheltt = m.eheltt + v.eheltt
				m.ehelt = m.ehelt + v.ehelt
				if v.elvl > m.elvl then m.elvl = v.elvl end
				m.elvl = m.elvl + 1
				if m.elvl >= level+5 then m.elvl = level+5 end
				table.remove(enemies, i)
			end
		end
		
	if love.math.random(160) == 1 then 
		v.path = love.math.random(1,2) 
		v.wdf = love.math.random(200,600)
		v.hgt = love.math.random(150,450)
	end
	
	if love.math.random(40-v.elvl) == 1 and love.math.random(12) == 1 then
		if sounds and v.rectx < 1000 and v.rectx > -200 and v.recty < 1000 and v.recty > -200 then
			esrc:setVolume(0.2)
			esrc:setPitch(0.8)
			esrc:stop()
			esrc:play()
		end
		
		local estartX = v.rectx + (v.rectw/2)
		local estartY = v.recty + (v.rectw/2)
		local eX = playerx + love.math.random(0 - (v.elvl*8),v.elvl*8)
		local eY = playery + love.math.random(0 - (v.elvl*8),v.elvl*8)
		local rad = v.elvl
        
		local eangle = math.atan2((eY - estartY), (eX - estartX))
        
		local ebulletDx = (5 * (v.elvl+5)) * math.cos(eangle)
		local ebulletDy = (5 * (v.elvl+5)) * math.sin(eangle)
		
		local ecolr = 255
		local ecolg = 100+love.math.random(55)
		local ecolb = 100+love.math.random(55)
		
       
		table.insert(ebullets, {x = estartX, y = estartY, dx = ebulletDx, dy = ebulletDy,col1 = ecolr, col2 = ecolg, col3 = ecolb,esradius = rad})
		
		
	end
		
	for i,v in ipairs(ebullets) do
		v.x = v.x + (v.dx * dt)
        v.y = v.y + (v.dy * dt)
		if v.x > 1000 then table.remove(ebullets,i) end
		if v.x < -200 then table.remove(ebullets,i) end
		if v.y > 1000 then table.remove(ebullets,i) end
		if v.y < -200 then table.remove(ebullets,i) end
		
		if colliding( v.x - (v.esradius/2), v.y - (v.esradius/2), v.esradius, v.esradius, playerx-(lzrsize/2), playery-(lzrsize/2), lzrsize, lzrsize ) then
			if sounds then
				src33:setVolume(0.3)
				src33:setPitch(0.5)
				src33:stop()
				src33:play()
			end
				
			count2 = 0
			stx = v.x
			sty = v.y
			stain2 = true
			table.remove(ebullets,i)
		end
		
	end
	ebull = false
	
	
	if count3 < 5 then v.slowY = v.recty - 10 v.slowX = v.rectx end
	v.rectxs = v.rectx
	v.rectys = v.recty
	
	if v.rectxs < 2 then v.rectxs = 2 v.rleft = true else v.rleft = false end
	if v.rectxs > 790 then v.rectxs = 790 v.rright = true else v.rright = false end
	
	if v.rectys < 20 then v.rectys = 20 v.rup = true else v.rup = false end
	if v.rectys > 572 then v.rectys = 572 v.rdown = true else v.rdown = false end
	
	
	v.rectw = 5 + v.ehelt/5
	v.recth = 5 + v.ehelt/5
	
	if v.rectx < -1000-(v.rectw*2) then 
		table.remove(enemies,i)
		encount = encount - 1
		enfunc()
	end
	if v.rectx > 1800+v.rectw then 
		table.remove(enemies,i)
		encount = encount - 1
		enfunc()
	end
	if v.recty < -1000-(v.rectw*2) then
		table.remove(enemies,i)
		encount = encount - 1
		enfunc()
	end
	if v.recty > 1600+v.rectw then 
		table.remove(enemies,i)
		encount = encount - 1
		enfunc()
	end
	
	rng478 = love.math.random(2)
	
	if rng478 == 1 then 
		if v.rectx + love.math.random(-v.wdf,v.wdf) < playerx then v.rectx = v.rectx + ((v.steprect/2)*60) * dt end
		if v.rectx + love.math.random(-v.wdf,v.wdf) > playerx then v.rectx = v.rectx - ((v.steprect/2)*60) * dt end
		if v.recty + love.math.random(-v.hgt,v.hgt) < playery then v.recty = v.recty + ((v.steprect/2)*60) * dt end
		if v.recty + love.math.random(-v.hgt,v.hgt) > playery then v.recty = v.recty - ((v.steprect/2)*60) * dt end
	end
	
	if rng478 >= 2 then
		local estartX = v.rectx
		local estartY = v.recty
		
		if v.path == 1 then
			eeX = playerx+v.wdf
			eeY = playery+v.hgt
		end
		
		if v.path == 2 then
			eeX = playerx+love.math.random(-50,50)
			eeY = playery+love.math.random(-50,50)
		end
        
		local eangle = math.atan2((eeY - estartY), (eeX - estartX))
        
		local ebulletDx = (3 * (v.elvl*love.math.random(5,12))) * math.cos(eangle)
		local ebulletDy = (3 * (v.elvl*love.math.random(5,12))) * math.sin(eangle)
		
		v.dx = ebulletDx
		v.dy = ebulletDy
		
		v.recty = v.recty + (v.dy * dt)
		v.rectx = v.rectx + (v.dx * dt)
			
	end
	
	if rng478 == 3 then
		local rng = love.math.random(8)
		if rng == 1 then v.rectx = v.rectx + (love.math.random(4)*60) * dt end
		if rng == 2 then v.rectx = v.rectx - (love.math.random(4)*60) * dt end
		if rng == 3 then v.recty = v.recty + (love.math.random(4)*60) * dt end
		if rng == 4 then v.recty = v.recty - (love.math.random(4)*60) * dt end
	end
	
	if playerx + radius > v.rectx and playerx - radius < v.rectx + v.rectw and playery + radius > v.recty and playery - radius < v.recty + v.recth and dmgsec > 0.3 and not lzrsw then
		dmgsec = 0
		dmg = true
		if sounds and shieldc <= 0 then
			src6:setVolume(1)
			src6:setPitch(1)
			src6:stop()
			src6:play()
		end
		
		if sounds and shieldc > 0 then
			src6:setVolume(1)
			src6:setPitch(3)
			src6:stop()
			src6:play()
		end
		
		edrng = love.math.random(0-math.floor(v.elvl/4),math.floor(v.elvl/4))
		shieldc = shieldc - v.elvl - edrng
		table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 1,x = playerx, y = playery, emsgc = 0, emsg = "-" .. v.elvl + edrng, r = 255, g = 0, b = 0})
		shieldsec = -7
		if shieldc <= 0 then shieldt = 0 + shieldc shieldc = 0 health = health + shieldt end
		if health <= 0 then
			health = 0
			savscore()
			gameIsPaused = true
			gameOver = true
			count2 = 0
			stx = playerx
			sty = playery
			stain = true
		end
	else 
		dmg = false
	end
	
	end
	
	for i,v in ipairs(bullets) do
        v.x = v.x + (v.dx * dt)
        v.y = v.y + (v.dy * dt)
		if v.x > 1200 then table.remove(bullets,i) end
		if v.x < -400 then table.remove(bullets,i) end
		if v.y > 1200 then table.remove(bullets,i) end
		if v.y < -400 then table.remove(bullets,i) end
		for q,w in ipairs(ebullets) do
				
				if v.x + sradius > w.x - w.esradius and v.x - sradius < w.x + w.esradius and v.y + sradius > w.y - w.esradius and v.y - sradius < w.y + w.esradius and not lzrsw then
				
					if sounds then
						src33:setVolume(0.3)
						src33:setPitch(0.5)
						src33:stop()
						src33:play()
					end
			
					count2 = 0
					stx = w.x
					sty = w.y
					stain2 = true
					table.remove(bullets,i)
					table.remove(ebullets,q)
				end
		end
    end
	
	
	if x100 <= 0 then xtemp = x100 x100 = 800 + xtemp end
	if x100 >= 800 then xtemp = x100 x100 = xtemp - 800 end
	
	if x200 <= 0 then xtemp = x200 x200 = 800 + xtemp end
	if x200 >= 800 then xtemp = x200 x200 = xtemp - 800 end
	
	if x300 <= 0 then xtemp = x300 x300 = 800 + xtemp end
	if x300 >= 800 then xtemp = x300 x300 = xtemp - 800 end
	
	if x400 <= 0 then xtemp = x400 x400 = 800 + xtemp end
	if x400 >= 800 then xtemp = x400 x400 = xtemp - 800 end
	
	if x500 <= 0 then xtemp = x500 x500 = 800 + xtemp end
	if x500 >= 800 then xtemp = x500 x500 = xtemp - 800 end
	
	if x600 <= 0 then xtemp = x600 x600 = 800 + xtemp end
	if x600 >= 800 then xtemp = x600 x600 = xtemp - 800 end
	
	if x700 <= 0 then xtemp = x700 x700 = 800 + xtemp end
	if x700 >= 800 then xtemp = x700 x700 = xtemp - 800 end
	
	if x800 <= 0 then xtemp = x800 x800 = 800 + xtemp end
	if x800 >= 800 then xtemp = x800 x800 = xtemp - 800 end
	
	if y100 <= 0 then ytemp = y100 y100 = 600 + ytemp end
	if y100 >= 600 then ytemp = y100 y100 = ytemp - 600 end
	
	if y100 <= 0 then ytemp = y100 y100 = 600 + ytemp end
	if y100 >= 600 then ytemp = y100 y100 = ytemp - 600 end
	
	if y200 <= 0 then ytemp = y200 y200 = 600 + ytemp end
	if y200 >= 600 then ytemp = y200 y200 = ytemp - 600 end
	
	if y300 <= 0 then ytemp = y300 y300 = 600 + ytemp end
	if y300 >= 600 then ytemp = y300 y300 = ytemp - 600 end
	
	if y400 <= 0 then ytemp = y400 y400 = 600 + ytemp end
	if y400 >= 600 then ytemp = y400 y400 = ytemp - 600 end
	
	if y500 <= 0 then ytemp = y500 y500 = 600 + ytemp end
	if y500 >= 600 then ytemp = y500 y500 = ytemp - 600 end
	
	if y600 <= 0 then ytemp = y600 y600 = 600 + ytemp end
	if y600 >= 600 then ytemp = y600 y600 = ytemp - 600 end
	
	if up then 		
		playery = 295 
		ty = ty - ((stepsize + boostt)*60)*dt
		for i,v in ipairs(bullets) do
			v.y = v.y + ((stepsize +  boostt)*60)*dt
		end
		for i,v in ipairs(ebullets) do
			v.y = v.y + ((stepsize +  boostt)*60)*dt
		end
		secrety = secrety + ((stepsize +  boostt)*60)*dt
		sty = sty + ((stepsize +  boostt)*60)*dt
		pky = pky + ((stepsize +  boostt)*60)*dt
		for i,v in ipairs(enemies) do
			v.recty = v.recty + ((stepsize +  boostt)*60)*dt
			v.slowY = v.slowY + ((stepsize +  boostt)*60)*dt
		end
		for i,v in ipairs(emsgt) do
			v.y = v.y + ((stepsize +  boostt)*60)*dt
		end
		y100 = y100 + ((stepsize +  boostt)*60)*dt
		y200 = y200 + ((stepsize +  boostt)*60)*dt
		y300 = y300 + ((stepsize +  boostt)*60)*dt
		y400 = y400 + ((stepsize +  boostt)*60)*dt
		y500 = y500 + ((stepsize +  boostt)*60)*dt
		y600 = y600 + ((stepsize +  boostt)*60)*dt
	end
	
	if down then	
		playery = 305 
		ty = ty + ((stepsize +  boostt)*60)*dt
		for i,v in ipairs(bullets) do
			v.y = v.y - ((stepsize + boostt)*60)*dt
		end
		for i,v in ipairs(ebullets) do
			v.y = v.y - ((stepsize + boostt)*60)*dt
		end
		secrety = secrety - ((stepsize + boostt)*60)*dt
		sty = sty - ((stepsize + boostt)*60)*dt
		pky = pky - ((stepsize + boostt)*60)*dt
		for i,v in ipairs(enemies) do		
			v.recty = v.recty - ((stepsize + boostt)*60)*dt
			v.slowY = v.slowY - ((stepsize + boostt)*60)*dt
		end
		for i,v in ipairs(emsgt) do
			v.y = v.y - ((stepsize + boostt)*60)*dt
		end
		y100 = y100 - ((stepsize + boostt)*60)*dt
		y200 = y200 - ((stepsize + boostt)*60)*dt
		y300 = y300 - ((stepsize + boostt)*60)*dt
		y400 = y400 - ((stepsize + boostt)*60)*dt
		y500 = y500 - ((stepsize + boostt)*60)*dt
		y600 = y600 - ((stepsize + boostt)*60)*dt
	end
	
	if left then 	
		playerx = 395 
		tx = tx - ((stepsize + boostt)*60)*dt
		for i,v in ipairs(bullets) do
			v.x = v.x + ((stepsize +  boostt)*60)*dt
		end
		for i,v in ipairs(ebullets) do
			v.x = v.x + ((stepsize +  boostt)*60)*dt
		end
		secretx = secretx + ((stepsize +  boostt)*60)*dt
		stx = stx + ((stepsize +  boostt)*60)*dt
		pkx = pkx + ((stepsize +  boostt)*60)*dt
		for i,v in ipairs(enemies) do
			v.rectx = v.rectx + ((stepsize +  boostt)*60)*dt
			v.slowX = v.slowX + ((stepsize +  boostt)*60)*dt
		end
		for i,v in ipairs(emsgt) do
			v.x = v.x + ((stepsize +  boostt)*60)*dt
		end
		x100 = x100 + ((stepsize +  boostt)*60)*dt
		x200 = x200 + ((stepsize +  boostt)*60)*dt
		x300 = x300 + ((stepsize +  boostt)*60)*dt
		x400 = x400 + ((stepsize +  boostt)*60)*dt
		x500 = x500 + ((stepsize +  boostt)*60)*dt
		x600 = x600 + ((stepsize +  boostt)*60)*dt
		x700 = x700 + ((stepsize +  boostt)*60)*dt
		x800 = x800 + ((stepsize +  boostt)*60)*dt
	end
	
	if right then 	
		playerx = 405 
		tx = tx + ((stepsize +  boostt)*60)*dt
		for i,v in ipairs(bullets) do
			v.x = v.x - ((stepsize + boostt)*60)*dt
		end
		for i,v in ipairs(ebullets) do
			v.x = v.x - ((stepsize + boostt)*60)*dt
		end
		secretx = secretx - ((stepsize + boostt)*60)*dt
		stx = stx - ((stepsize + boostt)*60)*dt
		pkx = pkx - ((stepsize + boostt)*60)*dt
		for i,v in ipairs(enemies) do
			v.rectx = v.rectx - ((stepsize + boostt)*60)*dt
			v.slowX = v.slowX - ((stepsize + boostt)*60)*dt
		end
		for i,v in ipairs(emsgt) do
			v.x = v.x - ((stepsize + boostt)*60)*dt
		end
		x100 = x100 - ((stepsize + boostt)*60)*dt
		x200 = x200 - ((stepsize + boostt)*60)*dt
		x300 = x300 - ((stepsize + boostt)*60)*dt
		x400 = x400 - ((stepsize + boostt)*60)*dt
		x500 = x500 - ((stepsize + boostt)*60)*dt
		x600 = x600 - ((stepsize + boostt)*60)*dt
		x700 = x700 - ((stepsize + boostt)*60)*dt
		x800 = x800 - ((stepsize + boostt)*60)*dt
	end
	
	
	if up == false and down == false and left == false and right == false then
		playery = 300
		playerx = 400
	end
	
	
	if pkx < 30		then pkx = 30 end
	if pkx > 770 	then pkx = 770 end
	if pky < 30 	then pky = 30 end
	if pky > 570 	then pky = 570 end
	
	
	for j,h in ipairs(enemies) do
		for u,m in ipairs(ebullets) do
			if m.x + m.esradius > playerx - radius and m.x - m.esradius < playerx + radius  and m.y + m.esradius > playery - radius and m.y - m.esradius < playery + radius then
			dmg = true
			table.remove(ebullets, u)
			if sounds and shieldc <= 0 then
				src6:setVolume(1)
				src6:setPitch(1)
				src6:stop()
				src6:play()
			end
		
			if sounds and shieldc > 0 then
				src6:setVolume(1)
				src6:setPitch(3)
				src6:stop()
				src6:play()
			end
			
			count2 = 0
			stx = playerx
			sty = playery
			stain = true
			edrng = love.math.random(0-math.floor(h.elvl/4),math.floor(h.elvl/4))
			shieldc = shieldc - h.elvl - edrng
			table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 1,x = playerx, y = playery, emsgc = 0, emsg = "-" .. h.elvl + edrng, r = 255, g = 0, b = 0})
			shieldsec = -7
			if shieldc <= 0 then shieldt = 0 + shieldc shieldc = 0 health = health + shieldt end
			if health <= 0 then
				health = 0
				gameIsPaused = true
				gameOver = true
				count2 = 0
				stx = playerx
				sty = playery
				stain = true
			end
			else 
				dmg = false
			
			end
		end
		
		if colliding( h.rectx, h.recty, h.rectw, h.recth, playerx-(lzrsize/2), playery-(lzrsize/2), lzrsize, lzrsize ) and lzrsec > 0.05 and lzrsw then
				lzrsec = 0
				drng = love.math.random(0-math.floor(hitpoints/5),math.floor(hitpoints/5))
				
				if h.elvl > level then drng = drng - love.math.random(h.elvl) end
				if h.elvl < level then drng = drng + love.math.random(h.elvl) end
				
				if drng <= 0-hitpoints then drng = 1-hitpoints end
				
				if love.math.random(100) == 1 and drng >= 0 then drng = drng + math.floor(hitpoints/2) end
				
				if drng + hitpoints > hitpoints then R = 0 G = 255 B = 0 end
				if drng + hitpoints == hitpoints then R = 255 G = 250 B = 0 end
				if drng + hitpoints < hitpoints then R = 255 G = 180 B = 0 end
				
				
				table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = h.slowX-5, y = h.slowY-30, emsgc = 0, emsg = "-" .. hitpoints + drng, r = R, g = G, b = B})
			
				shot = false
				if sounds then
					src3:setVolume(0.5)
					src3:stop()
					src3:play()
				end
				
				h.ehelt = h.ehelt - (hitpoints + drng)
				dps = dps + hitpoints + drng
				dtot = dtot + hitpoints + drng
				if h.ehelt <= 0 then 
			
				if sounds then
					src2:setVolume(0.6)
					src2:stop()
					src2:play()
				end
				count2 = 0
				if loot == false then
					pkx = h.rectx
					pky = h.recty
				end
				rng665 = 10
				if h.elvl > level then rng665 = 10 - ((h.elvl - level)*2) end
				if rng665 <= 0 then rng665 = 1 end
				if love.math.random(rng665) == 1 then
					loot = true
				end
		
				h.ehelt = 0
				killed = killed + 1
			
				rew = h.eheltt*10  msg = math.floor(rew/3) .. " XP"
				
				table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = h.rectx, y = h.recty, emsgc = 0, emsg = msg, r = 0, g = 255, b = 100})
				table.remove(enemies, j)
				encount = encount - 1
				Score = Score + rew
				count2 = 0
				stain = true
				end
				count3 = 0
				stx = h.rectx
				sty = h.recty
				stain2 = true
			end
		
		for i,v in ipairs(bullets) do
			if v.x + sradius > h.rectx and v.x - sradius < h.rectx + h.rectw and v.y + sradius > h.recty and v.y - sradius < h.recty + h.recth then
				
				drng = love.math.random(0-math.floor(hitpoints/5),math.floor(hitpoints/5))
				
				if h.elvl > level then drng = drng - love.math.random(h.elvl) end
				if h.elvl < level then drng = drng + love.math.random(h.elvl) end
				
				if drng <= 0-hitpoints then drng = 1-hitpoints end
				
				if love.math.random(100) == 1 and drng >= 0 then drng = drng + math.floor(hitpoints/2) end
				
				if drng + hitpoints > hitpoints then R = 0 G = 255 B = 0 end
				if drng + hitpoints == hitpoints then R = 255 G = 250 B = 0 end
				if drng + hitpoints < hitpoints then R = 255 G = 180 B = 0 end
				
				
				table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = h.slowX-5, y = h.slowY-30, emsgc = 0, emsg = "-" .. hitpoints + drng, r = R, g = G, b = B})
			
				shot = false
				if sounds then
					src3:setVolume(0.5)
					src3:stop()
					src3:play()
				end
				
				h.ehelt = h.ehelt - (hitpoints + drng)
				dps = dps + hitpoints + drng
				dtot = dtot + hitpoints + drng
				if h.ehelt <= 0 then 
			
				if sounds then
					src2:setVolume(0.6)
					src2:stop()
					src2:play()
				end
				count2 = 0
				if loot == false then
					pkx = h.rectx
					pky = h.recty
				end
				rng665 = 10
				if h.elvl > level then rng665 = 10 - ((h.elvl - level)*2) end
				if rng665 <= 0 then rng665 = 1 end
				if love.math.random(rng665) == 1 then
					loot = true
				end
		
				h.ehelt = 0
				killed = killed + 1
			
				rew = h.eheltt*10  msg = math.floor(rew/3) .. " XP"
				
				table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = v.x, y = v.y, emsgc = 0, emsg = msg, r = 0, g = 255, b = 100})
				table.remove(enemies, j)
				encount = encount - 1
				Score = Score + rew
				count2 = 0
				stain = true
				end
				count3 = 0
				stx = v.x
				sty = v.y
				stain2 = true
				table.remove(bullets, i)
			end
		end
	end
	
	
	if secretx + (secra*6) > playerx + radius and secretx - (secra*6) < playerx + radius and secrety + (secra*6) > playery + radius and secrety - (secra*6) < playery + radius then
		if sounds then
			src4:setVolume(1)
			src4:stop()
			src4:play()
		end
		secc = secc + 1
		
		reward()
		table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = playerx + 11, y = playery, emsgc = 0, emsg = msg, r = 30, g = 250, b = 100})
		secpla()
		
		
		
	end
	
	
	
	if loot == true and playerx + (radius*3) > pkx and playerx - (radius*3) < pkx + pkw and playery + (radius*3) > pky and playery - (radius*3) < pky + pkh then
		reward()
		table.insert(emsgt, {time = string.format("%02d:%02d:%02d",hour,min,math.floor(sec)) .. " - ",line = 0,x = pkx, y = pky, emsgc = 0, emsg = msg, r = 30, g = 250, b = 100})
		if sounds then
			src4:setVolume(1)
			src4:stop()
			src4:play()
		end
		
		loot = false
	end
	
end

function love.focus(f) end

function love.keypressed( key, unicode )

	if key == "u" then
		--Score = Score + 1000000
		--hipotints = 40
		--stepsize = 10
		--shots = 4
		--shieldm = 40
	end
	if key == "e" and lzrtime >= 0 and lzrlvl >= 1 then
		lzrsw = true
		lzrtime = 0
	end

    if key and key:match( '^[%w%s]$' ) and typing then 
		if spc and key ~= " " then spc = false end 
		if not spc then 
			if sounds then
				src9:setVolume(1)
				src9:stop()
				src9:play()
			end
			Name = string.upper (string.sub(Name .. key,1,16)) 
		end
		if key == " " then spc = true else spc = false end	
	end

	if key == "return" then
		typing = false
		love.keyboard.setTextInput(false)
	end

	if key == "backspace" and gameIsPaused then
		bcount = 13
		back = true
	end

	if key == "escape" then
		if pause == false and gameOver == false and scrolls == false then
			gameIsPaused = true
			pause = true
			scrolls2 = true
			scrolls = false
			scroll2 = -600
			if sounds then
				src10:setVolume(1)
				src10:stop()
				src10:play()
			end
		elseif gameOver == false and scrolls2 == false and chk == false then
			gameIsPaused = false
			pause = false
			chk = true
			scrolls = true
			scrolls2 = false
			scroll = 0
			if sounds then
				src10:setVolume(1)
				src10:stop()
				src10:play()
			end
		end
	end
	
	if key == "f4" then
		if logsw then 
			logsw = false 
		else
			logsw = true
		end
	end
	
	if key == "f5" then
		
		if colp == false then colp = true 
		
		else
			colp = false
		end
		
	end
	
	if key == "f6" then
		if fpssw then
			fpssw = false
		else
			fpssw = true
		end
	end
	
	if key == "f3" then
		if sounds == false then
			sounds = true
		else 
			sounds = false
			src:stop()
			src2:stop()
			src3:stop()
			src4:stop()
			src6:stop()
		end
	end
	
	if key == "f2" then
		if music == false then
			music = true
		else
			music = false
			src5:stop()
		end
	end
	
	if key == "end" then
		
	end
	
	if key == "f1" then
		if love.window.getFullscreen(true) then
			love.window.setFullscreen(false, "normal")
			fulls = false
		
		 
		 else
			love.window.setFullscreen(true, "normal")
			fulls = true
		 end
	end

	if key == "w" or key == "z" then
      up = true
	end
	
	if key == "s" then
      down = true
	end
	
	if key == "a" or key == "q" then
      left = true
	end
	
	if key == "d" then
      right = true
	end
	
end

function love.keyreleased( key, unicode )

	if key == "backspace" then back = false end

	if key == "w" or key == "z" then
      up = false
	end
	
	if key == "s" then
      down = false
	end
	
	if key == "a" or key == "q" then
      left = false
	end
	
	if key == "d" then
      right = false
	end
	
end

function love.mousepressed( x, y, button )
	if button == "l" or love.keyboard.isDown("return") then
		if not gameIsPaused and fires == false then fires = true else fires = false end
    end
end

function love.mousereleased( x, y, button )
	
end

function love.quit()
end